diff -Nur lwip/src/core/raw.c lwip-mcast/src/core/raw.c
--- lwip/src/core/raw.c	Fri Jan 26 13:32:36 2018
+++ lwip-mcast/src/core/raw.c	Sat Jan 27 16:55:18 2018
@@ -63,10 +63,10 @@
 #include <string.h>
 
 /** The list of RAW PCBs */
-static struct raw_pcb *raw_pcbs;
+struct raw_pcb *raw_pcbs;
 
 static u8_t
-raw_input_local_match(struct raw_pcb *pcb, u8_t broadcast)
+raw_input_local_match(struct raw_pcb *pcb, u8_t broadcast, struct netif *inp)
 {
   LWIP_UNUSED_ARG(broadcast); /* in IPv6 only case */
 
@@ -88,6 +88,12 @@
   }
 #endif /* LWIP_IPV4 && LWIP_IPV6 */
 
+#if (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD)
+  if (ip_addr_ismulticast(ip_current_dest_addr())) {
+    return mcast_input_local_match(&pcb->ipmc, inp);
+  }
+#endif /* (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD) */
+
   /* Only need to check PCB if incoming IP version matches PCB IP version */
   if (IP_ADDR_PCB_VERSION_MATCH_EXACT(pcb, ip_current_dest_addr())) {
 #if LWIP_IPV4
@@ -167,6 +173,17 @@
     if ((pcb->protocol == proto) && raw_input_local_match(pcb, broadcast) &&
         (((pcb->flags & RAW_FLAGS_CONNECTED) == 0) ||
          ip_addr_cmp(&pcb->remote_ip, ip_current_src_addr()))) {
+      if (pcb->min_ttl) {
+        if (ip_current_is_v6()) {
+          if (pcb->min_ttl > IP6H_HOPLIM(ip6_current_header())) {
+            continue;
+          }
+        } else {
+          if (pcb->min_ttl > IPH_TTL(ip4_current_header())) {
+            continue;
+          }
+        }
+      }
       /* receive callback function available? */
       if (pcb->recv != NULL) {
         u8_t eaten;
@@ -371,7 +388,26 @@
       /* For multicast-destined packets, use the user-provided interface index to
        * determine the outgoing interface, if an interface index is set and a
        * matching netif can be found. Otherwise, fall back to regular routing. */
-      netif = netif_get_by_index(pcb->mcast_ifindex);
+      if (pcb->mcast_ifindex != NETIF_NO_INDEX) {
+        netif = netif_get_by_index(pcb->mcast_ifindex);
+      }
+#if LWIP_IPV4
+      else
+#if LWIP_IPV6
+        if (IP_IS_V4(ipaddr))
+#endif /* LWIP_IPV6 */
+        {
+          /* IPv4 does not use source-based routing by default, so we use an
+             administratively selected interface for multicast by default.
+             However, this can be overridden by setting an interface address
+             in pcb->mcast_ip4 that is used for routing. If this routing lookup
+             fails, we try regular routing as though no override was set. */
+          if (!ip4_addr_isany_val(pcb->mcast_ip4) &&
+              !ip4_addr_cmp(&pcb->mcast_ip4, IP4_ADDR_BROADCAST)) {
+            netif = ip4_route_src(ip_2_ip4(&pcb->local_ip), &pcb->mcast_ip4);
+          }
+        }
+#endif /* LWIP_IPV4 */
     }
 
     if (netif == NULL)
@@ -449,6 +485,16 @@
     if (p->len < header_size) {
       return ERR_VAL;
     }
+#if CHECKSUM_GEN_IP
+    if (IP_IS_V4(dst_ip)) {
+      struct ip_hdr *iphdr = (struct ip_hdr *)p->payload;
+      if (IPH_CHKSUM(iphdr) == 0) {
+        IF__NETIF_CHECKSUM_ENABLED(netif, NETIF_CHECKSUM_GEN_IP) {
+          IPH_CHKSUM_SET(iphdr, inet_chksum(iphdr, IPH_HL(iphdr) << 2));
+        }
+      }
+    } 
+#endif /* CHECKSUM_GEN_IP */
     /* @todo multicast loop support, if at all desired for this scenario.. */
     NETIF_SET_HINTS(netif, &pcb->netif_hints);
     err = ip_output_if_hdrincl(p, src_ip, dst_ip, netif);
@@ -562,6 +608,11 @@
 {
   struct raw_pcb *pcb2;
   LWIP_ASSERT_CORE_LOCKED();
+
+#if (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD)
+  mcast_pcb_remove(&pcb->ipmc);
+#endif /* (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD) */
+
   /* pcb to be removed is first in list? */
   if (raw_pcbs == pcb) {
     /* make list start at 2nd pcb */
@@ -609,6 +660,9 @@
 #if LWIP_MULTICAST_TX_OPTIONS
     raw_set_multicast_ttl(pcb, RAW_TTL);
 #endif /* LWIP_MULTICAST_TX_OPTIONS */
+#if (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD)
+    pcb->ipmc.proto = IPPROTO_RAW;
+#endif /* (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD) */
     pcb->next = raw_pcbs;
     raw_pcbs = pcb;
   }
diff -Nur lwip/src/core/tcp_in.c lwip-mcast/src/core/tcp_in.c
--- lwip/src/core/tcp_in.c	Fri Jan 26 13:32:36 2018
+++ lwip-mcast/src/core/tcp_in.c	Sat Jan 27 16:56:21 2018
@@ -258,6 +258,17 @@
         pcb->local_port == tcphdr->dest &&
         ip_addr_cmp(&pcb->remote_ip, ip_current_src_addr()) &&
         ip_addr_cmp(&pcb->local_ip, ip_current_dest_addr())) {
+      if (pcb->min_ttl) {
+        if (ip_current_is_v6()) {
+          if (pcb->min_ttl > IP6H_HOPLIM(ip6_current_header())) {
+            goto dropped;
+          }
+        } else {
+          if (pcb->min_ttl > IPH_TTL(ip4_current_header())) {
+            goto dropped;
+          }
+        }
+      }
       /* Move this PCB to the front of the list so that subsequent
          lookups will be faster (we exploit locality in TCP segment
          arrivals). */
diff -Nur lwip/src/core/udp.c lwip-mcast/src/core/udp.c
--- lwip/src/core/udp.c	Fri Jan 26 13:32:36 2018
+++ lwip-mcast/src/core/udp.c	Sat Jan 27 16:58:51 2018
@@ -148,6 +148,12 @@
     return 1;
   }
 
+#if (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD)
+  if (ip_addr_ismulticast(ip_current_dest_addr())) {
+    return mcast_input_local_match(&pcb->ipmc, inp);
+  }
+#endif /* (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD) */
+
   /* Only need to check PCB if incoming IP version matches PCB IP version */
   if (IP_ADDR_PCB_VERSION_MATCH_EXACT(pcb, ip_current_dest_addr())) {
 #if LWIP_IPV4
@@ -269,6 +275,21 @@
       if ((pcb->remote_port == src) &&
           (ip_addr_isany_val(pcb->remote_ip) ||
            ip_addr_cmp(&pcb->remote_ip, ip_current_src_addr()))) {
+        if (pcb->min_ttl) {
+          if (ip_current_is_v6()) {
+            if (pcb->min_ttl > IP6H_HOPLIM(ip6_current_header())) {
+              UDP_STATS_INC(udp.drop);
+              pbuf_free(p);
+              goto end;
+            }
+          } else {
+            if (pcb->min_ttl > IPH_TTL(ip4_current_header())) {
+              UDP_STATS_INC(udp.drop);
+              pbuf_free(p);
+              goto end;
+            }
+          }
+        }
         /* the first fully matching PCB */
         if (prev != NULL) {
           /* move the pcb to the front of udp_pcbs so that is
@@ -1138,6 +1159,10 @@
 
   LWIP_ASSERT_CORE_LOCKED();
 
+#if (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD)
+  mcast_pcb_remove(&pcb->ipmc);
+#endif /* (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD) */
+
   mib2_udp_unbind(pcb);
   /* pcb to be removed is first in list? */
   if (udp_pcbs == pcb) {
@@ -1187,6 +1212,9 @@
 #if LWIP_MULTICAST_TX_OPTIONS
     udp_set_multicast_ttl(pcb, UDP_TTL);
 #endif /* LWIP_MULTICAST_TX_OPTIONS */
+#if (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD)
+    pcb->ipmc.proto = IPPROTO_UDP;
+#endif /* (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD) */
   }
   return pcb;
 }
diff -Nur lwip/src/include/lwip/api.h lwip-mcast/src/include/lwip/api.h
--- lwip/src/include/lwip/api.h	Fri Jan 26 13:32:36 2018
+++ lwip-mcast/src/include/lwip/api.h	Sat Jan 27 17:03:22 2018
@@ -84,6 +84,8 @@
 #if LWIP_NETBUF_RECVINFO
 /** Received packet info will be recorded for this netconn */
 #define NETCONN_FLAG_PKTINFO                  0x40
+/** Received hoplim will be recorded for this netconn */
+#define NETCONN_FLAG_HOPLIM                   0x80
 #endif /* LWIP_NETBUF_RECVINFO */
 
 
diff -Nur lwip/src/include/lwip/igmp.h lwip-mcast/src/include/lwip/igmp.h
--- lwip/src/include/lwip/igmp.h	Fri Jan 26 13:32:36 2018
+++ lwip-mcast/src/include/lwip/igmp.h	Sat Jan 27 17:05:10 2018
@@ -51,6 +51,13 @@
 extern "C" {
 #endif
 
+/* Multicast filter support */
+struct igmp_src {
+  struct igmp_src *next;
+  /** the source address */
+  ip4_addr_t src_addr;
+};
+
 /* IGMP timer */
 #define IGMP_TMR_INTERVAL              100 /* Milliseconds */
 #define IGMP_V1_DELAYING_MEMBER_TMR   (1000/IGMP_TMR_INTERVAL)
@@ -60,6 +67,10 @@
 #define IGMP_DEL_MAC_FILTER            NETIF_DEL_MAC_FILTER
 #define IGMP_ADD_MAC_FILTER            NETIF_ADD_MAC_FILTER
 
+#if LWIP_IGMP_V3
+#define IGMP_FMODE_INIT                2 /* Not MCAST_INCLUDE or MCAST_EXCLUDE */
+#endif /* LWIP_IGMP_V3 */
+
 /**
  * igmp group structure - there is
  * a list of groups for each interface
@@ -82,6 +93,16 @@
   u8_t               group_state;
   /** timer for reporting, negative is OFF */
   u16_t              timer;
+#if LWIP_IGMP_V3
+  /** Last report fmode */
+  u8_t               v3_fmode;
+  /** signifies we were the last person to report */
+  u8_t               v3_last_reporter_flag;
+  /** current state of the group */
+  u8_t               v3_group_state;
+  /** timer for reporting, negative is OFF */
+  u16_t              v3_timer;
+#endif /* LWIP_IGMP_V3 */
   /** counter of simultaneous uses */
   u8_t               use;
 };
diff -Nur lwip/src/include/lwip/ip.h lwip-mcast/src/include/lwip/ip.h
--- lwip/src/include/lwip/ip.h	Fri Jan 26 13:32:36 2018
+++ lwip-mcast/src/include/lwip/ip.h	Sat Jan 27 17:06:02 2018
@@ -84,7 +84,9 @@
   /* Type Of Service */                    \
   u8_t tos;                                \
   /* Time To Live */                       \
-  u8_t ttl                                 \
+  u8_t ttl;                                \
+  /* min TTL */                            \
+  u8_t min_ttl                             \
   /* link layer address resolution hint */ \
   IP_PCB_NETIFHINT
 
diff -Nur lwip/src/include/lwip/mcast.h lwip-mcast/src/include/lwip/mcast.h
--- lwip/src/include/lwip/mcast.h	Thu Jan  1 08:00:00 1970
+++ lwip-mcast/src/include/lwip/mcast.h	Tue Jan 23 15:35:02 2018
@@ -0,0 +1,175 @@
+/**
+ * @file
+ * Multicast filter module\n
+ */
+
+/*
+ * Copyright (c) 2018 Han.hui
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without modification,
+ * are permitted provided that the following conditions are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright notice,
+ *    this list of conditions and the following disclaimer in the documentation
+ *    and/or other materials provided with the distribution.
+ * 3. The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+ * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
+ * SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
+ * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
+ * OF SUCH DAMAGE.
+ *
+ * This file is part of the lwIP TCP/IP stack.
+ *
+ * Author: Han.hui <hanhui@acoinfo.com>
+ *
+ */
+#ifndef LWIP_HDR_MCAST_H
+#define LWIP_HDR_MCAST_H
+
+#include "lwip/opt.h"
+
+#if LWIP_UDP || LWIP_RAW /* don't build if not configured for use in lwipopts.h */
+
+#include "lwip/def.h"
+#include "lwip/ip.h"
+#include "lwip/ip_addr.h"
+#include "lwip/ip6_addr.h"
+#include "lwip/netif.h"
+#include "lwip/igmp.h"
+#include "lwip/mld6.h"
+#include "lwip/sockets.h"
+#include "lwip/prot/ip4.h"
+#include "lwip/prot/ip6.h"
+
+#ifndef LWIP_MCAST_SRC_TBL_SIZE
+#define LWIP_MCAST_SRC_TBL_SIZE  32
+#endif /* !LWIP_MCAST_TABLE_SIZE */
+
+#if LWIP_IPV4 && LWIP_IGMP
+/** the IPv4 multicast filter */
+struct ip4_mc {
+  struct ip4_mc *next;
+  /** the interface address */
+  ip4_addr_t if_addr;
+  /** the group address */
+  ip4_addr_t multi_addr;
+  /** the source address list filter mode 0: EXCLUDE 1: INCLUDE */
+  u8_t fmode;
+  /** the source address list */
+  struct igmp_src *src;
+};
+
+/** The list of ip4_mc. */
+#define IP4_MC_FOREACH(ipmc, mc) \
+  for ((mc) = (ipmc)->mc4; (mc) != NULL; (mc) = (mc)->next)
+#define IP4_MC_SRC_FOREACH(mc, src) \
+  for ((src) = (mc)->src; (src) != NULL; (src) = (src)->next)
+#endif /* LWIP_IPV4 && LWIP_IGMP */
+
+#if LWIP_IPV6 && LWIP_IPV6_MLD
+/** the IPv6 multicast filter */
+struct ip6_mc {
+  struct ip6_mc *next;
+  /** the interface index */
+  u8_t if_idx;
+  /** the group address */
+  ip6_addr_t multi_addr;
+  /** the source address list filter mode 0: EXCLUDE 1: INCLUDE */
+  u8_t fmode;
+  /** the source address list */
+  struct mld6_src *src;
+};
+
+/** The list of ip6_mc. */
+#define IP6_MC_FOREACH(ipmc, mc) \
+  for ((mc) = (ipmc)->mc6; (mc) != NULL; (mc) = (mc)->next)
+#define IP6_MC_SRC_FOREACH(mc, src) \
+  for ((src) = (mc)->src; (src) != NULL; (src) = (src)->next)
+#endif /* LWIP_IPV6 && LWIP_IPV6_MLD */
+
+#if (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD)
+/* multicast filter control block */
+struct ip_mc {
+#if !LWIP_SOCKET
+#define IPPROTO_UDP 17
+#define IPPROTO_RAW 255
+#endif /* !LWIP_SOCKET */
+  u8_t proto; /* IPPROTO_UDP or IPPROTO_RAW */
+
+#if LWIP_IPV4 && LWIP_IGMP
+  struct ip4_mc *mc4;
+#endif /* LWIP_IPV4 && LWIP_IGMP */
+
+#if LWIP_IPV6 && LWIP_IPV6_MLD
+  struct ip6_mc *mc6;
+#endif /* LWIP_IPV6 && LWIP_IPV6_MLD */
+};
+
+#if LWIP_IPV4 && LWIP_IGMP && LWIP_IGMP_V3
+/* IGMPv3 must install a trigger function to report multicast filter changes */
+typedef void (*mcast_trigger_ip4_fn)(struct netif *netif, const ip4_addr_t *multi_addr);
+void    mcast_ip4_filter_trigger_callback(mcast_trigger_ip4_fn trigger_callback);
+/* IGMPv3 use the following function to get specified group of total multicast filter source address array */
+u16_t   mcast_ip4_filter_info(struct netif *netif, const ip4_addr_t *multi_addr, ip4_addr_p_t addr_array[], u16_t arr_cnt, u8_t *fmode);
+u8_t    mcast_ip4_filter_interest(struct netif *netif, const ip4_addr_t *multi_addr, const ip4_addr_p_t src_addr[], u16_t arr_cnt);
+#endif /* LWIP_IPV4 && LWIP_IGMP && LWIP_IGMP_V3 */
+
+#if LWIP_IPV6 && LWIP_IPV6_MLD && LWIP_IPV6_MLD_V2
+/* MLDv2 must install a trigger function to report multicast filter changes */
+typedef void (*mcast_trigger_ip6_fn)(struct netif *netif, const ip6_addr_t *multi_addr);
+void    mcast_ip6_filter_trigger_callback(mcast_trigger_ip6_fn trigger_callback);
+/* MLDv2 use the following function to get specified group of total multicast filter source address array */
+u16_t   mcast_ip6_filter_info(struct netif *netif, const ip6_addr_t *multi_addr, ip6_addr_p_t addr_array[], u16_t arr_cnt, u8_t *fmode);
+u8_t    mcast_ip6_filter_interest(struct netif *netif, const ip6_addr_t *multi_addr, const ip6_addr_p_t src_addr[], u16_t arr_cnt);
+#endif /* LWIP_IPV6 && LWIP_IPV6_MLD && LWIP_IPV6_MLD_V2 */
+
+/* UDP or RAW use the following functions */
+void    mcast_pcb_remove(struct ip_mc *ipmc);
+u8_t    mcast_input_local_match(struct ip_mc *ipmc, struct netif *inp);
+
+/* The following functions is for Non-Socket API user */
+err_t   mcast_join_netif(struct ip_mc *ipmc, struct netif *netif, const ip_addr_t *multi_addr, const ip_addr_t *src_addr);
+err_t   mcast_join_group(struct ip_mc *ipmc, const ip_addr_t *if_addr, const ip_addr_t *multi_addr, const ip_addr_t *src_addr);
+err_t   mcast_leave_netif(struct ip_mc *ipmc, struct netif *netif, const ip_addr_t *multi_addr, const ip_addr_t *src_addr);
+err_t   mcast_leave_group(struct ip_mc *ipmc, const ip_addr_t *if_addr, const ip_addr_t *multi_addr, const ip_addr_t *src_addr);
+err_t   mcast_block_netif(struct ip_mc *ipmc, struct netif *netif, const ip_addr_t *multi_addr, const ip_addr_t *blk_addr);
+err_t   mcast_block_group(struct ip_mc *ipmc, const ip_addr_t *if_addr, const ip_addr_t *multi_addr, const ip_addr_t *blk_addr);
+err_t   mcast_unblock_netif(struct ip_mc *ipmc, struct netif *netif, const ip_addr_t *multi_addr, const ip_addr_t *unblk_addr);
+err_t   mcast_unblock_group(struct ip_mc *ipmc, const ip_addr_t *if_addr, const ip_addr_t *multi_addr, const ip_addr_t *unblk_addr);
+
+/* The following functions is for socket API use */
+#if LWIP_SOCKET
+err_t   mcast_set_msfilter_netif(struct ip_mc *ipmc, struct netif *netif, const ip_addr_t *multi_addr, const struct ip_msfilter *imsf);
+err_t   mcast_set_groupfilter_netif(struct ip_mc *ipmc, struct netif *netif, const ip_addr_t *multi_addr, const struct group_filter *gf);
+err_t   mcast_get_msfilter_netif(struct ip_mc *ipmc, struct netif *netif, const ip_addr_t *multi_addr, struct ip_msfilter *imsf, socklen_t *bufsz);
+err_t   mcast_get_groupfilter_netif(struct ip_mc *ipmc, struct netif *netif, const ip_addr_t *multi_addr, struct group_filter *gf, socklen_t *bufsz);
+
+int     mcast_sock_add_drop_membership(struct ip_mc *ipmc, int optname, const struct ip_mreq *imr);
+int     mcast_sock_add_drop_source_membership(struct ip_mc *ipmc, int optname, const struct ip_mreq_source *imr);
+int     mcast_sock_block_unblock_source(struct ip_mc *ipmc, int optname, const struct ip_mreq_source *imr);
+int     mcast_sock_set_msfilter(struct ip_mc *ipmc, int optname, const struct ip_msfilter *imsf);
+int     mcast_sock_get_msfilter(struct ip_mc *ipmc, int optname, struct ip_msfilter *imsf, socklen_t *size);
+int     mcast_sock_join_leave_group(struct ip_mc *ipmc, int optname, const struct group_req *gr);
+int     mcast_sock_join_leave_source_group(struct ip_mc *ipmc, int optname, const struct group_source_req *gsr);
+int     mcast_sock_block_unblock_source_group(struct ip_mc *ipmc, int optname, const struct group_source_req *gsr);
+int     mcast_sock_set_groupfilter(struct ip_mc *ipmc, int optname, const struct group_filter *gf);
+int     mcast_sock_get_groupfilter(struct ip_mc *ipmc, int optname, struct group_filter *gf, socklen_t *size);
+int     mcast_sock_ipv6_add_drop_membership(struct ip_mc *ipmc, int optname, const struct ipv6_mreq *imr);
+#endif /* LWIP_SOCKET */
+
+#endif /* (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD) */
+
+#endif /* LWIP_UDP || LWIP_RAW */
+
+#endif /* LWIP_HDR_MCAST_H */
diff -Nur lwip/src/include/lwip/mld6.h lwip-mcast/src/include/lwip/mld6.h
--- lwip/src/include/lwip/mld6.h	Fri Jan 26 13:32:36 2018
+++ lwip-mcast/src/include/lwip/mld6.h	Sat Jan 27 17:07:13 2018
@@ -54,6 +54,13 @@
 extern "C" {
 #endif
 
+/* Multicast filter support */
+struct mld6_src {
+  struct mld6_src *next;
+  /** the source address */
+  ip6_addr_t src_addr;
+};
+
 /** MLD group */
 struct mld_group {
   /** next link */
diff -Nur lwip/src/include/lwip/netbuf.h lwip-mcast/src/include/lwip/netbuf.h
--- lwip/src/include/lwip/netbuf.h	Fri Jan 26 13:32:36 2018
+++ lwip-mcast/src/include/lwip/netbuf.h	Sat Jan 27 17:08:11 2018
@@ -55,6 +55,8 @@
 #define NETBUF_FLAG_DESTADDR    0x01
 /** This netbuf includes a checksum */
 #define NETBUF_FLAG_CHKSUM      0x02
+/** This netbuf has hoplim set */
+#define NETBUF_FLAG_HOPLIM      0x80
 
 /** "Network buffer" - contains data and addressing info */
 struct netbuf {
@@ -66,6 +68,9 @@
   u16_t toport_chksum;
 #if LWIP_NETBUF_RECVINFO
   ip_addr_t toaddr;
+#if LWIP_IPV6
+  u8_t hoplim;
+#endif /* LWIP_IPV6 */
 #endif /* LWIP_NETBUF_RECVINFO */
 #endif /* LWIP_NETBUF_RECVINFO || LWIP_CHECKSUM_ON_COPY */
 };
diff -Nur lwip/src/include/lwip/opt.h lwip-mcast/src/include/lwip/opt.h
--- lwip/src/include/lwip/opt.h	Fri Jan 26 13:32:36 2018
+++ lwip-mcast/src/include/lwip/opt.h	Sat Jan 27 17:09:46 2018
@@ -1063,10 +1063,16 @@
  */
 #if !defined LWIP_IGMP || defined __DOXYGEN__
 #define LWIP_IGMP                       0
+/**
+ * LWIP_IGMP_V3==1: Turn on IGMPv3 module.
+ */
+#define LWIP_IGMP_V3                    0
 #endif
 #if !LWIP_IPV4
 #undef LWIP_IGMP
 #define LWIP_IGMP                       0
+#undef LWIP_IGMP_V3
+#define LWIP_IGMP_V3                    0
 #endif
 /**
  * @}
@@ -2489,6 +2495,13 @@
  */
 #if !defined LWIP_IPV6_MLD || defined __DOXYGEN__
 #define LWIP_IPV6_MLD                   (LWIP_IPV6)
+#endif
+
+/**
+ * LWIP_IPV6_MLD_V2==1: Enable multicast listener discovery protocol v2.
+ */
+#if !defined LWIP_IPV6_MLD_V2 || defined __DOXYGEN__
+#define LWIP_IPV6_MLD_V2                0
 #endif
 
 /**
diff -Nur lwip/src/include/lwip/prot/igmp.h lwip-mcast/src/include/lwip/prot/igmp.h
--- lwip/src/include/lwip/prot/igmp.h	Fri Jan 26 13:32:36 2018
+++ lwip-mcast/src/include/lwip/prot/igmp.h	Sat Jan 27 17:01:29 2018
@@ -49,6 +49,7 @@
  */
 #define IGMP_TTL                       1
 #define IGMP_MINLEN                    8
+#define IGMP_V3_MINLEN                 12
 #define ROUTER_ALERT                   0x9404U
 #define ROUTER_ALERTLEN                4
 
@@ -59,6 +60,7 @@
 #define IGMP_V1_MEMB_REPORT            0x12 /* Ver. 1 membership report */
 #define IGMP_V2_MEMB_REPORT            0x16 /* Ver. 2 membership report */
 #define IGMP_LEAVE_GROUP               0x17 /* Leave-group message      */
+#define IGMP_V3_MEMB_REPORT            0x22 /* Ver. 3 membership report */
 
 /* Group  membership states */
 #define IGMP_GROUP_NON_MEMBER          0
@@ -82,6 +84,79 @@
 #ifdef PACK_STRUCT_USE_INCLUDES
 #  include "arch/epstruct.h"
 #endif
+
+#if LWIP_IGMP_V3 /* RFC 3367 */
+/**
+ * IGMPv3 query packet format.
+ */
+#ifdef PACK_STRUCT_USE_INCLUDES
+#  include "arch/bpstruct.h"
+#endif
+PACK_STRUCT_BEGIN
+struct igmp_v3_query {
+  PACK_STRUCT_FLD_8(u8_t         igmp_v3_msgtype);
+  PACK_STRUCT_FLD_8(u8_t         igmp_v3_maxresp);
+  PACK_STRUCT_FIELD(u16_t        igmp_v3_checksum);
+  PACK_STRUCT_FLD_S(ip4_addr_p_t igmp_v3_group_address);
+  PACK_STRUCT_FLD_8(u8_t         igmp_v3_sqrv);
+  PACK_STRUCT_FLD_8(u8_t         igmp_v3_qqic);
+  PACK_STRUCT_FIELD(u16_t        igmp_v3_srccnt);
+} PACK_STRUCT_STRUCT;
+PACK_STRUCT_END
+#ifdef PACK_STRUCT_USE_INCLUDES
+#  include "arch/epstruct.h"
+#endif
+
+#define IGMP_V3_QUERY_HLEN  sizeof(struct igmp_v3_query)
+
+/**
+ * IGMPv3 report packet header format.
+ */
+#ifdef PACK_STRUCT_USE_INCLUDES
+#  include "arch/bpstruct.h"
+#endif
+PACK_STRUCT_BEGIN
+struct igmp_v3_report {
+  PACK_STRUCT_FLD_8(u8_t         igmp_v3_msgtype);
+  PACK_STRUCT_FLD_8(u8_t         igmp_v3_reserve1);
+  PACK_STRUCT_FIELD(u16_t        igmp_v3_checksum);
+  PACK_STRUCT_FIELD(u16_t        igmp_v3_reserve2);
+  PACK_STRUCT_FIELD(u16_t        igmp_v3_reccnt);
+} PACK_STRUCT_STRUCT;
+PACK_STRUCT_END
+#ifdef PACK_STRUCT_USE_INCLUDES
+#  include "arch/epstruct.h"
+#endif
+
+#define IGMP_V3_REPORT_HLEN  sizeof(struct igmp_v3_report)
+
+#define IGMP_V3_REC_IS_IN   0x01    /* Type MODE_IS_INCLUDE */
+#define IGMP_V3_REC_IS_EX   0x02    /* Type MODE_IS_EXCLUDE */
+#define IGMP_V3_REC_TO_IN   0x03    /* Type CHANGE_TO_INCLUDE_MODE */
+#define IGMP_V3_REC_TO_EX   0x04    /* Type CHANGE_TO_EXCLUDE_MODE */
+#define IGMP_V3_REC_ALLOW   0x05    /* Type ALLOW_NEW_SOURCES */
+#define IGMP_V3_REC_BLOCK   0x06    /* Type BLOCK_OLD_SOURCES */
+
+/**
+ * IGMPv3 report packet group record format.
+ */
+#ifdef PACK_STRUCT_USE_INCLUDES
+#  include "arch/bpstruct.h"
+#endif
+PACK_STRUCT_BEGIN
+struct igmp_v3_record {
+  PACK_STRUCT_FLD_8(u8_t         igmp_v3_rc_type);
+  PACK_STRUCT_FLD_8(u8_t         igmp_v3_rc_auxlen);
+  PACK_STRUCT_FIELD(u16_t        igmp_v3_rc_srccnt);
+  PACK_STRUCT_FLD_S(ip4_addr_p_t igmp_v3_rc_group_address);
+} PACK_STRUCT_STRUCT;
+PACK_STRUCT_END
+#ifdef PACK_STRUCT_USE_INCLUDES
+#  include "arch/epstruct.h"
+#endif
+
+#define IGMP_V3_RECORD_LEN(src_cnt)  (sizeof(struct igmp_v3_record) + (src_cnt << 2))
+#endif /* LWIP_IGMP_V3 */
 
 #ifdef __cplusplus
 }
diff -Nur lwip/src/include/lwip/raw.h lwip-mcast/src/include/lwip/raw.h
--- lwip/src/include/lwip/raw.h	Fri Jan 26 13:32:36 2018
+++ lwip-mcast/src/include/lwip/raw.h	Sat Jan 27 17:11:28 2018
@@ -47,6 +47,7 @@
 #include "lwip/ip.h"
 #include "lwip/ip_addr.h"
 #include "lwip/ip6_addr.h"
+#include "lwip/mcast.h"
 
 #ifdef __cplusplus
 extern "C" {
@@ -82,12 +83,20 @@
   u8_t flags;
 
 #if LWIP_MULTICAST_TX_OPTIONS
+#if LWIP_IPV4
+  /** outgoing network interface for multicast packets, by IPv4 address (if not 'any') */
+  ip4_addr_t mcast_ip4;
+#endif /* LWIP_IPV4 */
   /** outgoing network interface for multicast packets, by interface index (if nonzero) */
   u8_t mcast_ifindex;
   /** TTL for outgoing multicast packets */
   u8_t mcast_ttl;
 #endif /* LWIP_MULTICAST_TX_OPTIONS */
 
+#if (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD)
+  struct ip_mc ipmc;
+#endif /* (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD) */
+
   /** receive callback function */
   raw_recv_fn recv;
   /* user-supplied argument for the recv callback */
@@ -98,6 +107,7 @@
   u8_t  chksum_reqd;
 #endif
 };
+extern struct raw_pcb *raw_pcbs;
 
 /* The following functions is the application layer interface to the
    RAW code. */
@@ -128,6 +138,10 @@
 #define raw_new_ip6(proto) raw_new_ip_type(IPADDR_TYPE_V6, proto)
 
 #if LWIP_MULTICAST_TX_OPTIONS
+#if LWIP_IPV4
+#define raw_set_multicast_netif_addr(pcb, ip4addr) ip4_addr_copy((pcb)->mcast_ip4, *(ip4addr))
+#define raw_get_multicast_netif_addr(pcb)          (&(pcb)->mcast_ip4)
+#endif /* LWIP_IPV4 */
 #define raw_set_multicast_netif_index(pcb, idx) ((pcb)->mcast_ifindex = (idx))
 #define raw_get_multicast_netif_index(pcb)      ((pcb)->mcast_ifindex)
 #define raw_set_multicast_ttl(pcb, value)       ((pcb)->mcast_ttl = (value))
diff -Nur lwip/src/include/lwip/sockets.h lwip-mcast/src/include/lwip/sockets.h
--- lwip/src/include/lwip/sockets.h	Fri Jan 26 13:32:36 2018
+++ lwip-mcast/src/include/lwip/sockets.h	Sat Jan 27 17:16:08 2018
@@ -269,6 +269,17 @@
 #define IP_TOS             1
 #define IP_TTL             2
 #define IP_PKTINFO         8
+#define IP_MINTTL          99
+#define IP_HDRINCL         100
+#define IP_OPTIONS         101
+
+#if LWIP_IPV6
+#define IPV6_RECVPKTINFO    49  /* Recv IPV6_PKTINFO message */
+#define IPV6_PKTINFO        50
+#define IPV6_RECVHOPLIMIT   51  /* Recv IPV6_HOPLIMIT message */
+#define IPV6_HOPLIMIT       52
+#define IPV6_MINHOPCNT      99
+#endif /* LWIP_IPV6 */
 
 #if LWIP_TCP
 /*
@@ -315,11 +326,78 @@
 #define IP_DROP_MEMBERSHIP 4
 
 typedef struct ip_mreq {
-    struct in_addr imr_multiaddr; /* IP multicast address of group */
-    struct in_addr imr_interface; /* local IP address of interface */
+  struct in_addr imr_multiaddr; /* IP multicast address of group */
+  struct in_addr imr_interface; /* local IP address of interface */
 } ip_mreq;
+
+/* IPv4 Source Filter Multicast API [RFC3678] */
+#define IP_UNBLOCK_SOURCE           37   /* unblock a source */
+#define IP_BLOCK_SOURCE             38   /* block a source */
+#define IP_ADD_SOURCE_MEMBERSHIP    39   /* join a source-specific group */
+#define IP_DROP_SOURCE_MEMBERSHIP   40   /* drop a single source */
+#define IP_MSFILTER                 41   /* set/get msfilter */
+/*
+ * Argument structure for IPv4 Multicast Source Filter APIs. [RFC3678]
+ */
+struct ip_mreq_source {
+  struct in_addr imr_multiaddr;   /* IP multicast address of group */
+  struct in_addr imr_sourceaddr;  /* IP address of source */
+  struct in_addr imr_interface;   /* local IP address of interface */
+};
+
+#define IP_MSFILTER_SIZE(numsrc) \
+  (sizeof(struct ip_msfilter) - sizeof(struct in_addr) \
+   + (numsrc) * sizeof(struct in_addr))
+
+struct ip_msfilter {
+  struct in_addr imsf_multiaddr;
+  struct in_addr imsf_interface;
+  u32_t          imsf_fmode;
+#define MCAST_EXCLUDE   0
+#define MCAST_INCLUDE   1
+  u32_t          imsf_numsrc;
+  struct in_addr imsf_slist[1];
+};
 #endif /* LWIP_IGMP */
 
+#if (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD)
+/* Protocol Independent Multicast API [RFC3678] */
+#define MCAST_JOIN_GROUP            42   /* join an any-source group */
+#define MCAST_BLOCK_SOURCE          43   /* block a source */
+#define MCAST_UNBLOCK_SOURCE        44   /* unblock a source */
+#define MCAST_LEAVE_GROUP           45   /* leave all sources for group */
+#define MCAST_JOIN_SOURCE_GROUP     46   /* join a source-specific group */
+#define MCAST_LEAVE_SOURCE_GROUP    47   /* leave a single source */
+#define MCAST_MSFILTER              48
+
+/*
+ * Argument structures for Protocol-Independent Multicast Source
+ * Filter APIs. [RFC3678]
+ */
+struct group_req {
+  u32_t                     gr_interface;   /* interface index */
+  struct sockaddr_storage   gr_group;       /* group address */
+};
+
+struct group_source_req {
+  u32_t                     gsr_interface;  /* interface index */
+  struct sockaddr_storage   gsr_group;      /* group address */
+  struct sockaddr_storage   gsr_source;     /* source address */
+};
+
+#define GROUP_FILTER_SIZE(numsrc) \
+    (sizeof(struct group_filter) - sizeof(struct sockaddr_storage) \
+     + (numsrc) * sizeof(struct sockaddr_storage))
+
+struct group_filter {
+    u32_t                   gf_interface;   /* interface index */
+    struct sockaddr_storage gf_group;       /* multicast address */
+    u32_t                   gf_fmode;       /* filter mode */
+    u32_t                   gf_numsrc;      /* number of sources */
+    struct sockaddr_storage gf_slist[1];    /* interface index */
+};
+#endif /* #if (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD) */
+
 #if LWIP_IPV4
 struct in_pktinfo {
   unsigned int   ipi_ifindex;  /* Interface index */
@@ -327,7 +405,19 @@
 };
 #endif /* LWIP_IPV4 */
 
+#if LWIP_IPV6
+struct in6_pktinfo {
+  struct in6_addr ipi6_addr;
+  int             ipi6_ifindex;
+};
+#endif /* LWIP_IPV6 */
+
 #if LWIP_IPV6_MLD
+#define IPV6_UNICAST_HOPS    16 /* IPv6 ttl */
+#define IPV6_MULTICAST_IF    17 /* Set mcast ifindex, (The argument is a pointer to an interface index) */
+#define IPV6_MULTICAST_HOPS  18 /* IPv6 mcast ttl */
+#define IPV6_MULTICAST_LOOP  19 /* Mcast loop */
+
 /*
  * Options and types related to IPv6 multicast membership
  */
diff -Nur lwip/src/include/lwip/udp.h lwip-mcast/src/include/lwip/udp.h
--- lwip/src/include/lwip/udp.h	Fri Jan 26 13:32:36 2018
+++ lwip-mcast/src/include/lwip/udp.h	Sat Jan 27 17:12:28 2018
@@ -48,6 +48,7 @@
 #include "lwip/ip.h"
 #include "lwip/ip6_addr.h"
 #include "lwip/prot/udp.h"
+#include "lwip/mcast.h"
 
 #ifdef __cplusplus
 extern "C" {
@@ -100,6 +101,10 @@
   /** TTL for outgoing multicast packets */
   u8_t mcast_ttl;
 #endif /* LWIP_MULTICAST_TX_OPTIONS */
+
+#if (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD)
+  struct ip_mc ipmc;
+#endif /* (LWIP_IPV4 && LWIP_IGMP) || (LWIP_IPV6 && LWIP_IPV6_MLD) */
 
 #if LWIP_UDPLITE
   /** used for UDP_LITE only */
